/*!
 * @file      WasGetMailCount.h
 * @brief        īƮ.
 * @author    Yangjae.park(yangjae.park@nhn.com)
 * @date      2012-03-09 
 * @warning   
 */

#pragma once

#include "ActorInterface.h"
#include "wascommand.h"
#include "WASActor.h"

class CWASGetMailCount : public CWASCommand
{
public:
	CWASGetMailCount(CWASActor *pActor);
	~CWASGetMailCount(void);

	void ExecuteAsync(void);

private:
	bool ParseAndEventFire(Json::Value * json);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		Json::Value * /*json*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	NTNMailErrorCode	m_eMailError;

	INT64				m_ulPrevMailSN;
	INT64				m_totalUnreadMail;
};



class CWASGetMailPreview : public CWASCommand
{
public:
	CWASGetMailPreview(CWASActor *pActor);
	~CWASGetMailPreview(void);

	void ExecuteAsync(void);

	void SetParameter(INT64 ulMailSerial)
	{
		m_ulMailSerial = ulMailSerial;
	}

private:
	bool ParseAndEventFire(Json::Value * json);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		Json::Value * /*json*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	INT64		m_ulMailSerial;

	wstring		m_strSubject;
	wstring		m_strContent;
	wstring		m_strSenderName;
	wstring		m_strSenderID;
};
